%
% Copyright (c) 2005 Carnegie Mellon University.  All rights
% reserved.
%
% Redistribution and use in source and binary forms, with or without
% modification, are permitted provided that the following conditions
% are met:
%
% 1. Redistributions of source code must retain the above copyright
%    notice, this list of conditions and the following disclaimer.
%
% 2. Redistributions in binary form must reproduce the above copyright
%    notice, this list of conditions and the following disclaimer in
%    the documentation and/or other materials provided with the
%    distribution.
%
% 3. The end-user documentation included with the redistribution,
%    if any, must include the following acknowledgment:
%       "This product includes software developed by
%        Carnegie Mellon University (http://www.cmu.edu/)."
%    Alternately, this acknowledgment may appear in the software itself,
%    if and wherever such third-party acknowledgments normally appear.
%
% 4. The names "Carnegie Mellon University" and "CMU" must
%    not be used to endorse or promote products derived from this
%    software.
%
% 5. Products derived from this software may not be called
%     "Carnegie Mellon University" or "CMU",
%    nor may "Carnegie Mellon University"  or "CMU" appear in their name.
%
% THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
% WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
% OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
% DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
% ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
% SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
% LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
% USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
% ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
% OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
% OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
% SUCH DAMAGE.
%
% @ProposedRating yellow jingcao@ece.cmu.edu
%

function latency = calc_latency(lambda, mu)

dimension = size(mu);
num_of_rows = dimension(1);
num_of_cols = dimension(2);
num_of_dirs = dimension(3);

%% now calculate the average packet latency by sum(lambda/(mu-lambda))
%% final implementation
latency = 0.;
for l = 1 : num_of_rows
  for m = 1 : num_of_cols
    for n = 1 : num_of_dirs
      latency = latency + lambda(l,m,n) / (mu(l,m,n) - lambda(l,m,n));
    end
  end
end


%% old implemetation
% global b;
% diff = -1;
% latency = -1;
% for i = 1 : num_of_rows
%   for j = 1 : num_of_cols
%     for k = 1 : num_of_dirs
%       ro(i,j,k) = lambda(i,j,k) / mu(i,j,k);
%       if k == 1 | b(i,j,k) == 0
%         diff = -1;
%       else
%         diff = lambda(i,j,k) - (1 - ro(i,j,k)^b(i,j,k)) / (1 - ro(i,j,k)^(b(i,j,k) + 1));
%         if diff > latency
%           latency = diff;
%         end
%       end
%     end
%   end
% end
    
