/*
 * Copyright (c) 2005 Carnegie Mellon University.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by
 *        Carnegie Mellon University (http://www.cmu.edu/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Carnegie Mellon University" and "CMU" must
 *    not be used to endorse or promote products derived from this
 *    software.
 *
 * 5. Products derived from this software may not be called
 *     "Carnegie Mellon University" or "CMU",
 *    nor may "Carnegie Mellon University"  or "CMU" appear in their name.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * @ProposedRating yellow jingcao@ece.cmu.edu
 */

#ifndef MSG_HPP_
#define MSG_HPP_

// Error messages
#define ERRO_PARSING_OPTIONS "[E] Error in parsing options.\n"
#define ERRO_UNRECOGNIZED_OPTION "[E] Unrecognized option "
#define ERRO_NETWORK_BUILD_ERROR "[E] Network creation error.\n"
#define ERRO_ARCH_NOT_SUPPORTED "[E] Architecture type not supported.\n"
#define ERRO_TOPO_ROUT_NOT_COMBINABLE "[E] Unsupported topology and routing mode combination.\n"
#define ERRO_RESOURCE_NOT_FOUND "[E] Resource can not be found.\n"
#define ERRO_NOT_HEADER_FLIT "[E] Can not perform the required action on header flit.\n"
#define ERRO_WRAP_CLOCK "[E] Simulation too long, net clock wrapped.\n"
#define ERRO_TRAFFIC_PATTEN_NOT_SUPPORTED "[E] Traffic pattern not supported.\n"
#define ERRO_PROC_PACKET "[E] Error in processing packet.\n"
#define ERRO_BAD_HOTSPOT_PARAM "[E] Bad hotspot traffic parameters.\n"
#define ERRO_BAD_TRACE_FILE "[E] Bad trace file "
#define ERRO_PARSING_TRACE_FILE "[E] Error in parsing trace file.\n"
#define ERRO_CONFIG_FILE "[E] Error in parsing config file.\n"
#define ERRO_PACKET_RATE "[E] packet generating rate can not be larger than one.\n"
#define ERRO_EQUATION_FILE "[E] can not generate equation file.\n"
#define ERRO_OPEN_FILE "[E] in opening file.\n"
#define ERRO_UNSUPPORTED_ROUT_FOR_ANA "[E] unsupported routing mode for analysis.\n"

// Warning messages
#define WARN_BUFFER_OVERFLOW "[W] Possible buffer overflow.\n"
#define WARN_PACKET_RATE "[W] Can not apply packet rate.\n"
#define WARN_EQN_NOT_SOLVABLE "[W] The generated performance equation may not be solvable.\n"
#define WARN_OPTION_CONFIG_FILE "[W] Unrecognized option in configuration file: "
#define WARN_EMPTY_TRACE_FILE "[W] Attaching an empty trace file: "

// Informational messages
#define INFO_TIMER_FIRED "[I] Routing engine timer fired."
#define INFO_CONFIG_NODE "[I] Apply configuration on node "
#define INFO_SIM_DONE "[I] Simulation completed successfully.\n"


#endif  // MSG_HPP_
